1#!/bin/bash
2# perf stat CSV output linter
3# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
4# Tests various perf stat CSV output commands for the
5# correct number of fields and the CSV separator set to ','.
6
7set -e
8
9# shellcheck source=lib/stat_output.sh
10. "$(dirname $0)"/lib/stat_output.sh
11
12csv_sep=@
13
14stat_output=$(mktemp /tmp/__perf_test.stat_output.csv.XXXXX)
15
16cleanup() {
17  rm -f "${stat_output}"
18
19  trap - EXIT TERM INT
20}
21
22trap_cleanup() {
23  cleanup
24  exit 1
25}
26trap trap_cleanup EXIT TERM INT
27
28function commachecker()
29{
30	local -i cnt=0
31	local exp=0
32
33	case "$1"
34	in "--no-args")		exp=6
35	;; "--system-wide")	exp=6
36	;; "--event")		exp=6
37	;; "--interval")	exp=7
38	;; "--per-thread")	exp=7
39	;; "--system-wide-no-aggr")	exp=7
40				[ "$(uname -m)" = "s390x" ] && exp='^[6-7]$'
41	;; "--per-core")	exp=8
42	;; "--per-socket")	exp=8
43	;; "--per-node")	exp=8
44	;; "--per-die")		exp=8
45	;; "--per-cluster")	exp=8
46	;; "--per-cache")	exp=8
47	esac
48
49	while read line
50	do
51		# Ignore initial "started on" comment.
52		x=${line:0:1}
53		[ "$x" = "#" ] && continue
54		# Ignore initial blank line.
55		[ "$line" = "" ] && continue
56
57		# Count the number of commas
58		x=$(echo $line | tr -d -c $csv_sep)
59		cnt="${#x}"
60		# echo $line $cnt
61		[[ ! "$cnt" =~ $exp ]] && {
62			echo "wrong number of fields. expected $exp in $line" 1>&2
63			exit 1;
64		}
65	done < "${stat_output}"
66	return 0
67}
68
69perf_cmd="-x$csv_sep -o ${stat_output}"
70
71skip_test=$(check_for_topology)
72check_no_args "CSV" "$perf_cmd"
73check_system_wide "CSV" "$perf_cmd"
74check_interval "CSV" "$perf_cmd"
75check_event "CSV" "$perf_cmd"
76check_per_thread "CSV" "$perf_cmd"
77check_per_node "CSV" "$perf_cmd"
78if [ $skip_test -ne 1 ]
79then
80	check_system_wide_no_aggr "CSV" "$perf_cmd"
81	check_per_core "CSV" "$perf_cmd"
82	check_per_cache_instance "CSV" "$perf_cmd"
83	check_per_cluster "CSV" "$perf_cmd"
84	check_per_die "CSV" "$perf_cmd"
85	check_per_socket "CSV" "$perf_cmd"
86else
87	echo "[Skip] Skipping tests for system_wide_no_aggr, per_core, per_die and per_socket since socket id exposed via topology is invalid"
88fi
89cleanup
90exit 0
91